jQuery(document).ready(function($){

    var $cg_backend_info_container;

    jQuery(document).on('click', '.cg_media_note_manage_additional_files', function( event ){
        $(this).closest('.media-modal').find('.media-modal-close').click();
        $cg_backend_info_container.find('.cg_manage_multiple_files_for_post').click();
    });

    // Media uploader multiple images to a post

    jQuery(document).on('click', '#cgSortable .cg_add_multiple_files_to_post, #cgSortable .cg_add_multiple_files_to_post_prev', function( event ){

        var file_frame;
        $cg_backend_info_container = $(this).closest('.cg_backend_info_container');
        var realId = $cg_backend_info_container.attr('data-cg-real-id');
        event.preventDefault();

        // If the media frame already exists, reopen it.
        if ( file_frame ) {
            // Set the post ID to what we want
            file_frame.uploader.uploader.param( 'post_id', cg_media_uploader_set_to_post_id );
            // Open frame
            file_frame.open();
            try {// do it here for sure, file_frame.open has to be done before
                //      wp.media.frame.content.get('gallery').collection.props.set({ignore: (+ new Date())});// <<< old code, reload, because images might be deleted (or added) from storage
                //https://wordpress.stackexchange.com/questions/325886/update-media-library-attachments
                // this forces a refresh of the content
                wp.media.frame.content.get().collection._requery(true);
                // optional: reset selection
                wp.media.frame.content.get().options.selection.reset();
            } catch(e) {
                console.log(e);
            }
            return;
        } else {
            // Set the wp.media post id so the uploader grabs the ID we want when initialised
            wp.media.model.settings.post.id = cg_media_uploader_set_to_post_id;
        }

        // Create the media frame.
        file_frame = wp.media.frames.file_frame = wp.media({
            title: jQuery( this ).data( 'uploader_title' ),
            button: {
                text: jQuery( this ).data( 'uploader_button_text' ),
            },
            multiple: true  // Set to true to allow multiple files to be selected
        });

        var data;
        var order;

        if(!cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]){
            var cg_multiple_files_for_post = $cg_backend_info_container.find('.cg_multiple_files_for_post').val();
            if(cg_multiple_files_for_post){
                cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId] = JSON.parse(cg_multiple_files_for_post);
            }
        }

        if(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]){
            data = cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId];
            for(var orderMultipleFilesForPost in cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]){
                if(!cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId].hasOwnProperty(orderMultipleFilesForPost)){
                    break;
                }
                if(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId][orderMultipleFilesForPost].isRealIdSource){
                    data[orderMultipleFilesForPost] = cgJsClassAdmin.gallery.functions.setMultipleFileForPostFromBackendInfoContainer($cg_backend_info_container,true);
                }
            }
            order = Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length;
            order++;
        }else{
            data = {};
            order = 1;
            data[order] = cgJsClassAdmin.gallery.functions.setMultipleFileForPostFromBackendInfoContainer($cg_backend_info_container,true);
            order++;
        }

        file_frame.on( 'open', function() { // alert(2);
            file_frame.$el.addClass('cg_backend_area cg_add_additional_files');
            file_frame.$el.find('#media-frame-title').html(
                '<div class="cg_media_note"><div class="cg_media_note_explanation">Add additional files and click through them in frontend like on Instagram</div></div>'
            );

            if(location.search.indexOf('page=contest-gallery-pro')>-1){
                if(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId] && (Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length>1)){// >1 because file might be added and then origin deleted
                    file_frame.$el.find('#media-frame-title .cg_media_note').append(
                        '<div class="cg_media_note_actions"><div class="cg_media_note_pro_hint">Max additional files: <span>+9</span></div>'+
                        '<div class="cg_media_note_manage_additional_files">Manage already added additional files ('+(Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length-1)+')</div>' +
                        '</div>'
                    );
                }else{
                    file_frame.$el.find('#media-frame-title .cg_media_note').append(
                        '<div class="cg_media_note_actions"><div class="cg_media_note_pro_hint">Max additional files: <span>+9</span></div>'+
                        '</div>'
                    );
                }
            }else{
                if(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId] && (Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length>1)){// >1 because file might be added and then origin deleted
                    file_frame.$el.find('#media-frame-title .cg_media_note').append(
                        '<div class="cg_media_note_actions"><div class="cg_media_note_pro_hint">Max additional files: <span>+2</span> <span class="cg-pro-false">+9</span></div>'+
                        '<div class="cg_media_note_manage_additional_files">Manage already added additional files ('+(Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length-1)+')</div>' +
                        '</div>'
                    );
                }else{
                    file_frame.$el.find('#media-frame-title .cg_media_note').append(
                        '<div class="cg_media_note_actions"><div class="cg_media_note_pro_hint">Max additional files: <span>+2</span> <span class="cg-pro-false">+9</span></div>'+
                        '</div>'
                    );
                }
            }
            console.log(file_frame);
            console.log(this);
            console.log('opened');
        });

        var isDynamicMessageVisible = false;

        // When an image is selected, run a callback.
        file_frame.on( 'select', function() { // alert(2);
            // We set multiple to false so only get one image from the uploader
            var attachment = file_frame.state().get('selection').toJSON();
            var i = 0;
            var countAdded = 0;
            var isBreakDone = false;

            while (i < attachment.length){

                var hasRealIdAlready = false;

                for(var orderToCheck in data){
                    if(!data.hasOwnProperty(orderToCheck)){
                        break;
                    }
                    if(data[orderToCheck].WpUpload==attachment[i].id || $cg_backend_info_container.attr('data-cg-wp-upload')==attachment[i].id){
                        hasRealIdAlready = true; break;
                    }
                }

                if(hasRealIdAlready){
                    isDynamicMessageVisible = true;
                    cgJsClassAdmin.gallery.functions.setAndAppearBackendGalleryDynamicMessage('One of the files you trying to add is already added');
                    i++;continue;
                }

                if(location.search.indexOf('page=contest-gallery-pro')>-1 && Object.keys(data).length>=10){
                    isDynamicMessageVisible = true;
                    cgJsClassAdmin.gallery.functions.setAndAppearBackendGalleryDynamicMessage('Maxim allowed additional files: <b>9</b>');
                    break;
                }else{
                    if(location.search.indexOf('page=contest-gallery-pro')==-1 && Object.keys(data).length>=3){
                        isBreakDone = true;
                        isDynamicMessageVisible = true;
                        cgJsClassAdmin.gallery.functions.setAndAppearBackendGalleryDynamicMessage('<span style="font-weight: normal;">Maxim allowed additional files<br>in normal version: </span><b>2</b><br>' +
                            '<span style="font-weight: normal;">Maxim allowed additional files<br>in PRO version: </span><b>9</b>');
                        break;
                    }
                }

                console.log(attachment[i]);

                var ImgType = attachment[i].url.split('.')[attachment[i].url.split('.').length-1].toLowerCase()// short version of type (subtype in wordpress), relevant for classes search

                if(cgJsClassAdmin.gallery.vars.allowedFileEndings.indexOf(ImgType)==-1){
                    isDynamicMessageVisible = true;
                    cgJsClassAdmin.gallery.functions.setAndAppearBackendGalleryDynamicMessage('One of the file types you trying to add is not allowed');
                    i++;continue;
                }else{
                    if(location.search.indexOf('page=contest-gallery-pro')==-1 && ['pdf','zip','wav','mp3','mp4','mov'].indexOf(ImgType)>-1){
                        isDynamicMessageVisible = true;
                        cgJsClassAdmin.gallery.functions.setAndAppearBackendGalleryDynamicMessage('One of the file types you trying to add is only allowed to add in PRO version in backend');
                        i++;continue;
                    }
                }
                countAdded++;

                if(typeof attachment[i].date == 'number'){// then must be new added and time * 1000
                    attachment[i].date = new Date(attachment[i].date * 1000);
                }

                var hours = "0" + attachment[i].date.getHours();
                var minutes = "0" + attachment[i].date.getMinutes();
                var seconds = "0" + attachment[i].date.getSeconds();
                var timeReadable = hours.substr(-2) + ':' + minutes.substr(-2) + ':' + seconds.substr(-2);

                var cgFormatDate = function (date) {
                    var d = new Date(date);
                    var month = '' + (d.getMonth() + 1);
                    var day = '' + d.getDate();
                    var year = d.getFullYear();
                    if (month.length < 2)
                        month = '0' + month;
                    if (day.length < 2)
                        day = '0' + day;
                    return [year, month, day].join('-');
                }

                var post_date = cgFormatDate(attachment[i].date) + ' ' + timeReadable;

                data[order] = {
                    WpUpload:attachment[i].id,
                    order:order,
                    rThumb:0,
                    Exif:'',
                    post_alt:attachment[i].alt,
                    post_title:attachment[i].title,
                    post_name:attachment[i].name,
                    post_content:attachment[i].description,
                    post_excerpt:attachment[i].caption,
                    post_mime_type:attachment[i].mime,
                    post_date:post_date,
                    NamePic:attachment[i].name,
                    Width:0,// should be simply set already here to avoid undefined array keys
                    Height:0,// should be simply set already here to avoid undefined array keys
                    medium:'',// should be simply set already here to avoid undefined array keys
                    large:'',// should be simply set already here to avoid undefined array keys
                    full:attachment[i].url,
                    guid:attachment[i].url,
                    type:attachment[i].type,// WordPress type
                    ImgType: ImgType
                }

                // WordPress type
                if(attachment[i].type=='image' && attachment[i].sizes){
                    data[order]['medium'] = (attachment[i].sizes.medium && attachment[i].sizes.medium.url) ? attachment[i].sizes.medium.url : attachment[i].url;// if medium not exists then image must be small, without generated medium
                    data[order]['large'] = (attachment[i].sizes.large && attachment[i].sizes.large.url) ? attachment[i].sizes.large.url : attachment[i].url;// if large not exists then image must be small, without generated large
                }else{
                    if(attachment[i].type=='image'){
                        data[order]['large'] = attachment[i].url;
                    }
                }
                if((attachment[i].type=='image' || attachment[i].type=='video') && attachment[i].height){
                    data[order]['Width'] = attachment[i].width;
                    data[order]['Height'] = attachment[i].height;
                }
                cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId] = data;
                i++;
                order++;
            }

            if(countAdded==0){
                return;
            }

            console.log('cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]');
            console.log(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]);

            var calculateFirst = Object.keys(data).length-1;
            var toStringFirst = '+'+calculateFirst;

            $cg_backend_info_container.find('.cg_manage_multiple_files_for_post_prev, .cg_manage_multiple_files_for_post').removeClass('cg_hide');
            $cg_backend_info_container.find('.cg_manage_multiple_files_for_post').text(toStringFirst);

            cgJsClassAdmin.gallery.functions.setSimpleDataRealIdSource(realId,$cg_backend_info_container);

            if(location.search.indexOf('page=contest-gallery-pro')>-1 && Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length>=10){
                $cg_backend_info_container.find('.cg_add_multiple_files_to_post, .cg_add_multiple_files_to_post_prev').addClass('cg_hide');
            }else{
                if(Object.keys(cgJsClassAdmin.gallery.vars.multipleFilesForPost[realId]).length>=10){
                    $cg_backend_info_container.find('.cg_add_multiple_files_to_post, .cg_add_multiple_files_to_post_prev').addClass('cg_hide');
                }
            }

            $cg_backend_info_container.find('.cg_manage_multiple_files_for_post, .cg_manage_multiple_files_for_post_prev').addClass('cg_blink');
            setTimeout(function (){
                $cg_backend_info_container.find('.cg_manage_multiple_files_for_post, .cg_manage_multiple_files_for_post_prev').removeClass('cg_blink');
            },2000);

            if(!isDynamicMessageVisible){
                $cg_backend_info_container.find('.cg_manage_multiple_files_for_post').click();
            }

            /*            if(countAdded && !isBreakDone){// seems to be better without it for understanding in the moment
                            $cg_backend_info_container.find('.cg_manage_multiple_files_for_post').click();
                        }*/

        });

        // Finally, open the modal
        file_frame.open();
        try {// do it here for sure, file_frame.open has to be done before
            //          wp.media.frame.content.get('gallery').collection.props.set({ignore: (+ new Date())});// <<< old code, reload, because images might be deleted (or added) from storage
            //https://wordpress.stackexchange.com/questions/325886/update-media-library-attachments
            // this forces a refresh of the content
            wp.media.frame.content.get().collection._requery(true);
            // optional: reset selection
            wp.media.frame.content.get().options.selection.reset();
        } catch(e) {
            console.log(e);
        }

    });

    // Media uploader general

    // Uploading files
    //var file_frame;
    //var wp_media_post_id = wp.media.model.settings.post.id; // Store the old id
    var cg_media_uploader_set_to_post_id = 0; // Set this

    jQuery(document).on('click', '.cg_upload_wp_images_button', function( event ){

        var file_frame;
        event.preventDefault();

        // If the media frame already exists, reopen it.
        if ( file_frame ) {
            // Set the post ID to what we want
            file_frame.uploader.uploader.param( 'post_id', cg_media_uploader_set_to_post_id );
            // Open frame
            file_frame.open();
            try {// do it here for sure, file_frame.open has to be done before
                //      wp.media.frame.content.get('gallery').collection.props.set({ignore: (+ new Date())});// <<< old code, reload, because images might be deleted (or added) from storage
                //https://wordpress.stackexchange.com/questions/325886/update-media-library-attachments
                // this forces a refresh of the content
                wp.media.frame.content.get().collection._requery(true);
                // optional: reset selection
                wp.media.frame.content.get().options.selection.reset();
            } catch(e) {
                console.log(e);
            }
            return;
        } else {
            // Set the wp.media post id so the uploader grabs the ID we want when initialised
            wp.media.model.settings.post.id = cg_media_uploader_set_to_post_id;
        }

        // Create the media frame.
        file_frame = wp.media.frames.file_frame = wp.media({
            title: jQuery( this ).data( 'uploader_title' ),
            button: {
                text: jQuery( this ).data( 'uploader_button_text' ),
            },
            multiple: true  // Set to true to allow multiple files to be selected
        });

        /*
                file_frame.on( 'open', function() { // alert(2);

                });
        */

        file_frame.on( 'open', function() { // alert(2);
            file_frame.$el.addClass('cg_backend_area');
        });


        // When an image is selected, run a callback.
        file_frame.on( 'select', function() { // alert(2);
            // We set multiple to false so only get one image from the uploader
            var attachment = file_frame.state().get('selection').toJSON();

            cgMediaUploadGallery(attachment);

            //$("#cg_wp_upload_ids").append("<input class='cg_wp_upload_id' value="+attachment.id+" />");

        });

        // Finally, open the modal
        file_frame.open();
        try {// do it here for sure, file_frame.open has to be done before
            //          wp.media.frame.content.get('gallery').collection.props.set({ignore: (+ new Date())});// <<< old code, reload, because images might be deleted (or added) from storage
            //https://wordpress.stackexchange.com/questions/325886/update-media-library-attachments
            // this forces a refresh of the content
            wp.media.frame.content.get().collection._requery(true);
            // optional: reset selection
            wp.media.frame.content.get().options.selection.reset();
        } catch(e) {
            console.log(e);
        }

        // have to be done because of possible wordpress media library bug
        setTimeout(function (){
            $('.button.load-more').removeClass('hidden');
            $('.load-more-jump').removeClass('hidden');
        },3000);

    });

    // Restore the main ID when the add media button is pressed
    //  jQuery('a.add_media').on('click', function() {
    //wp.media.model.settings.post.id = wp_media_post_id;
    //	alert(wp_media_post_id);
    //  });

    /*	   $(document).on('click', '.media-modal-close', function(e){


var file_frame;

return false;	

});*/

    function cgMediaUploadGallery(attachment){
        //	console.log('upload');
        var cg_gallery_id = $("#cg_gallery_id").val();
        var cg_admin_url = $("#cg_admin_url").val();

        $("#cg_uploading_count").css("display","none");

        if(attachment.length==0){return false;}

        $("#cg_uploading_gif").css("display","block");
        $("#cg_uploading_div").css("display","block");
        $("#cgAddImagesWpUploader").css("display","none");

        var i = 0;
        var attachmentIds = [];
        while (i < attachment.length){
            attachmentIds.push(attachment[i].id);
            i++;
        }

        jQuery.ajax({
            url : cg_admin_url+"admin-ajax.php",
            type : 'post',
            data : {
                action : 'cg_check_wp_admin_upload_v10',
                action1 : attachmentIds,
                action2 : cg_gallery_id
            },
        }).done(function(response) {
            $("#cgAddImagesWpUploader").css("display","block");
            var gid = $('#cgBackendGalleryId').val();
            $('#cgOrderSelect #cg_custom').prop('selected',true);
            localStorage.setItem('cgOrder_BG_'+gid, $('#cgOrderSelect').val());
            var $cgSearchInput = $('#cgSearchInput');
            $cgSearchInput.val('');
            $cgSearchInput.removeClass('cg_searched_value');
            localStorage.setItem('cgSearch_BG_'+gid, $cgSearchInput.val());

            if($('#cgStepsNavigationTop .cg_step').length){// reset start value to 0 then here!
                $('#cgStartValue').val(0);// input field for start value
                localStorage.setItem('cgStart_BG_'+gid, 0);
            }

            $('#cgViewControl').find('.cg_image_checkbox').removeClass('cg_active');
            $('#cgSearchInputClose').addClass('cg_hide');
            $('#cgSearchInputButton').addClass('cg_hide');
            $('#cgShowOnlyWinnersCheckbox').removeClass('cg_searched_value_checkbox').prop('checked',false);

            // to go simply sure that nothing will be deleted!!!
            $('#cgGalleryForm').find('.cg_delete').remove();

            var isImagesAdded = false;

            if(response.indexOf('cg-images-added')!=-1){
                isImagesAdded = true;
            }

            cgJsClassAdmin.gallery.load.init($,true,null, isImagesAdded,response);

        }).fail(function(xhr, status, error) {

            console.log(xhr);
            console.log(status);
            console.log(error);

        }).always(function() {

        });


    }


});